package de.gedoplan.beantrial.entitygraph.entity;

import de.gedoplan.baselibs.persistence.entity.GeneratedIntegerIdEntity;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.NamedAttributeNode;
import javax.persistence.NamedEntityGraph;
import javax.persistence.OneToMany;

@Entity
@Access(AccessType.FIELD)
//@NamedEntityGraphs({
@NamedEntityGraph(
    name = "Publisher_books",
    attributeNodes = @NamedAttributeNode(value = "books"))
//    ,
//    @NamedEntityGraph(
//        name = "Publisher_booksAndAuthors",
//        attributeNodes = @NamedAttributeNode(value = "books", subgraph = "Book_authors"),
//        subgraphs = @NamedSubgraph(name = "Book_authors", attributeNodes = @NamedAttributeNode("authors"))) 
//})
public class Publisher extends GeneratedIntegerIdEntity
{
  private static final long serialVersionUID = 1L;

  private String            name;

  @OneToMany(mappedBy = "publisher", fetch = FetchType.LAZY, cascade = CascadeType.PERSIST)
  private List<Book>        books;

  @ElementCollection(fetch = FetchType.LAZY)
  private List<String>      categories;

  protected Publisher()
  {
  }

  public Publisher(String name, String... categories)
  {
    this.name = name;

    this.books = new ArrayList<>();
    this.categories = new ArrayList<>(Arrays.asList(categories));
  }

  public String getName()
  {
    return this.name;
  }

  public void setName(String name)
  {
    this.name = name;
  }

  public List<Book> getBooks()
  {
    return Collections.unmodifiableList(this.books);
  }

  void addBook(Book book)
  {
    this.books.add(book);
  }

  void removeBook(Book book)
  {
    this.books.remove(book);
  }

  public List<String> getCategories()
  {
    return this.categories;
  }
}
